var Generator = require('yeoman-generator');
const yaml = require('js-yaml');

module.exports = class extends Generator{
  collect(){
    return this.prompt([
      {
        type    : 'input',
        name    : 'name',
        message : 'Your plugin name',
        default : 'MyPlugin'
      }
    ]).then(function (answers) {
      this.PluginName = answers.name
      //https://codereview.stackexchange.com/questions/109899/convert-string-to-spinal-case
      this.plugin_name = this.PluginName.replace(/(?!^)([A-Z])/g, ' $1').replace(/[_\s]+(?=[a-zA-Z])/g, '-').toLowerCase()
    }.bind(this));
  }

  install(){
    this.spawnCommandSync('mkdir',['api-'+this.plugin_name])
    var cwd = this.destinationRoot()
    this.destinationRoot('api-'+this.plugin_name)
    this.spawnCommandSync('git',['init'])
    this.spawnCommandSync('git',['pull','https://gitlab.com/expressive-analytics/deep-thought/sample-api-plugin.git'])

    this.fs.copyTpl(
      this.templatePath('composer.json'),
      this.destinationPath("composer.json"),
      { plugin_name: this.plugin_name, PluginName: this.PluginName }
    )
    this.fs.copyTpl(
      this.templatePath('migrations/_dtql.json'),
      this.destinationPath("migrations/_dtql.json"),
      { plugin_name: this.plugin_name, PluginName: this.PluginName }
    )
    this.fs.copyTpl(
      this.templatePath('Model/Sample.php'),
      this.destinationPath("src/Model/Sample.php"),
      { plugin_name: this.plugin_name, PluginName: this.PluginName }
    )
    this.fs.copyTpl(
      this.templatePath('Provider/Sample.php'),
      this.destinationPath("src/Provider/Sample.php"),
      { plugin_name: this.plugin_name, PluginName: this.PluginName }
    )
    this.spawnCommandSync('git',['remote','add','origin','git@gitlab.com:expressive-analytics/api-plugins/'+this.plugin_name+'.git'])
    this.destinationRoot(cwd)
  }
}
