var Generator = require('yeoman-generator');

module.exports = class extends Generator{
  prebuild() {
    this.spawnCommandSync('mkdir',['local'])
  }

  collect(){
    return this.prompt([
      {
        type    : 'input',
        name    : 'connector',
        message : 'Your database connector',
        default : 'sqlite'
      },{
        type    : 'input',
        name    : 'dsn',
        message : 'Your data source name (DSN)',
        default : 'sqlite:///var/www/deepthought/storage/dt-development.db'
      }
    ]).then(function (answers) {
      if(answers.connector=="sqlite")
        this.db_connector = "DTSQLiteDatabase"
      else if(answers.connector=="mysql")
        this.db_connector = "DTMySQLDatabase"
      else if(answers.connector=="pgsql")
        this.db_connector = "DTPgSQLDatabase"
      else this.db_connector = answers.connector
      this.db_dsn = answers.dsn

      // write storage.json
      // var f = "local/storage.json"
      // var stores = {}
      // if(this.fs.exists(f)){
      //   stores = this.fs.readJSON(f)
      // }
      // stores["default"] = {
      //   connector: this.db_connector,
      //   dsn: this.db_dsn
      // }
      // stores["relay"] = {
      //   connector: this.db_connector,
      //   dsn: this.db_dsn
      // }
      // this.fs.writeJSON(f,stores)

      // write config.json
      var f = "local/config.json"
      var config = {}
      if(this.fs.exists(f)){
        config = this.fs.readJSON(f)
      }
      config["base_url"] = "localhost:8000"
      var logs = "/var/log/error.log"
      config["logs"] = {
        error_log: logs,
        debug_log: logs,
        info_log: logs,
        permissions: "0777"
      }
      this.fs.writeJSON(f,config)
    }.bind(this));
  }
}
