var Generator = require('yeoman-generator');

module.exports = class extends Generator{
  collect() {
    return this.prompt([
      {
        type    : 'input',
        name    : 'model',
        message : 'Your model name?'
      },
      {
        type    : 'confirm',
        name    : 'customize',
        message : 'Do you need custom provider behaviors?',
        default : false
      }
    ]).then(function (answers) {
      var m = answers.model
      var f = 'apis.json';
      var apis = {}
      if(this.fs.exists(f))
        apis = this.fs.readJSON(f)
      if(typeof(apis['api'])=="undefined")
        apis['api'] = {'access':'r'}
      if(typeof(apis['api-oauth'])=="undefined")
        apis['api-oauth'] = {'access':'rw','verifier':'DTOAuthVerifier'}
      if(answers.customize){
        this.fs.copyTpl(
          this.templatePath('provider.php'),
          this.destinationPath("providers/"+m+"Provider.php"),
          { model: m }
        )
        this.fs.copyTpl(
          this.templatePath('secure_provider.php'),
          this.destinationPath("providers/secure/Secure"+m+"Provider.php"),
          { model: m }
        )
        apis['api']['providers'][m.toLowerCase()] = {'class':m+'Provider'}
        apis['api-oauth']['providers'][m.toLowerCase()] = {'class':'Secure'+m+'Provider'}
      } else {
        apis['api']['providers'][m.toLowerCase()] = {'model':m}
        apis['api-oauth']['providers'][m.toLowerCase()] = {'model':m}
      }
      this.fs.writeJSON(f,apis)
    }.bind(this));
  }
};
