var Generator = require('yeoman-generator');
const yaml = require('js-yaml');
var path = require('path');

module.exports = class extends Generator{
  collect() {
    return this.prompt([
      {
        type    : 'input',
        name    : 'name',
        message : 'Your relay name',
        default : 'relay'
      },{
        type    : 'input',
        name    : 'port',
        message : 'Your relay port',
        default : '8887'
      }
    ]).then(function (answers) {
      var cwd = this.destinationRoot()
      var project = cwd.split(path.sep).pop()
      this.relay_name = answers.name
      var f = "docker-compose.yaml"
      var root = {
        version: "3.8",
        services: {}
      }
      if(this.fs.exists(f)){
        root = yaml.load(this.fs.read(f))
      }
      root.services[answers.name] = {
        volumes: ["./logs:/var/log","./storage:/storage","./"+this.relay_name+":/app:ro","./local:/conf:ro","./local/apis.json:/run/secrets/apis:ro"],
        image: project+"-"+this.relay_name,
        links: ["api:api.local"],
        environment: ["DSN=${DSN}"],
        ports: [answers.port+":80"],
        "hostname": this.relay_name+".local"
      }
      this.fs.write(f,yaml.dump(root))
    }.bind(this));
  }

  install(){
    this.spawnCommandSync('mkdir',[this.relay_name])
    var cwd = this.destinationRoot()
    var project = cwd.split(path.sep).pop()
    this.destinationRoot(this.relay_name)
    this.spawnCommandSync('git',['init'])
    this.spawnCommandSync('git',['pull','https://gitlab.com/expressive-analytics/deep-thought/deep-thought-php-relay-server.git'])
    this.spawnCommandSync('git',['remote','add','origin','git@gitlab.com:expressive-analytics/'+project+'-'+this.relay_name+'.git'])
    this.spawnCommandSync('git',['checkout','-b','developer'])
    this.spawnCommandSync('composer',['install','--no-dev'])
    this.destinationRoot(cwd)
  }
}
