var Generator = require('yeoman-generator');
const yaml = require('js-yaml');
var path = require('path');

module.exports = class extends Generator{
  collect() {
    return this.prompt([
      {
        type    : 'input',
        name    : 'name',
        message : 'Your app name',
        default : 'site'
      }
    ]).then(function (answers) {
      var cwd = this.destinationRoot()
      var project = cwd.split(path.sep).pop()
      this.site_name = answers.name

      // no longer need to write to docker
    }.bind(this));
  }

  install(){
    this.spawnCommandSync('mkdir',[this.site_name])
    var cwd = this.destinationRoot()
    var project = cwd.split(path.sep).pop()
    this.destinationRoot(this.site_name)
    this.spawnCommandSync('git',['init'])
    this.spawnCommandSync('git',['pull','https://gitlab.com/expressive-analytics/deep-thought/vue3-seed.git'])
    this.spawnCommandSync('git',['remote','add','origin','git@gitlab.com:expressive-analytics/'+project+'-'+this.site_name+'.git'])
    this.spawnCommandSync('git',['checkout','-b','developer'])
    this.spawnCommandSync('npm',['install'])
    this.destinationRoot(cwd)
  }
}
